g_spawns = {}

--playerWep[slot][playa]

addEventHandler("onResourceStart", resourceRoot,
	function()
		if tonumber(get("spawnType")) >= 1 then
			local file = xmlLoadFile("spawns.xml")
			if file then
				for i, node in pairs(xmlNodeGetChildren(file)) do
					local x = xmlNodeGetAttribute(node, "posX")
					local y = xmlNodeGetAttribute(node, "posY")
					local z = xmlNodeGetAttribute(node, "posZ")
					local rot = xmlNodeGetAttribute(node, "rot")
					local int = xmlNodeGetAttribute(node, "int")
					local spawn = {x, y, z, rot, int}
					table.insert(g_spawns, spawn)
				end
			end
			
			if #g_spawns == 0 then
				outputServerLog("CLASS SELECTION: No spawns detected! See your spawns.xml file.")
				set("spawnType", "0")
			else		
				addEventHandler("onPlayerWasted", root,
					function()
						setTimer(spawnPlayerEx, tonumber(get("respawnDelay")) * 1000, 1, source)
					end
				)
			end
		end
	end
)

function spawnPlayerEx(player, skin, spawn)
	if not spawn or spawn > #g_spawns then
		if get("spawnType") == "2" then
			spawn = math.random(1, #g_spawns)
		else spawn = 1 end
	end
	local x, y, z, rot, int = unpack(g_spawns[spawn])
	if not skin then
		skin = getElementModel(player) or 0
	end
	
	local jetpack = doesPedHaveJetPack(player)
	local weapons = {}
	local weapons_a = {}
	if get("allowWeapons") == "1" then
		for i=1, 13 do
			local w = getPedWeapon(player, i - 1)
			weapons[i] = w
			weapons_a[i] = getPedTotalAmmo(player, i - 1)
			--outputChatBox("S " .. i - 1 .. " W " .. weapons[i] .. " A " .. weapons_a[i])
		end
	end	
	
	spawnPlayer(player, x, y, z, rot, skin, int)
	setCameraTarget(player)
	
	if get("allowWeapons") == "1" then
		for i, w in pairs(weapons) do
			giveWeapon(player, w, weapons_a[i], true)
		end
		if weapons[1] == 1 then giveWeapon(player, 1, 1, true) end -- brass knuckles haxxx
	end
	
	if jetpack and get("allowJetpack") == "1" then
		givePedJetPack(source)
	end
end

-- events from clientside
function onPlayerEnterClassSelection()
	if get("allowJetpack") == "0" then
		removePedJetPack(source)
	else
		if doesPedHaveJetPack(source) then
			setTimer(givePedJetPack, 100, 1, source) -- jetpack update (because if ped position is changed jetpack disappear)
		end
	end
end
addEvent("onPlayerEnterClassSelection", true)
addEventHandler("onPlayerEnterClassSelection", root, onPlayerEnterClassSelection)

function onPlayerLeaveClassSelection(skin)
	if tonumber(get("spawnType")) >= 1 then		
		spawnPlayerEx(source, skin)
	end
end
addEvent("onPlayerLeaveClassSelection", true)
addEventHandler("onPlayerLeaveClassSelection", root, onPlayerLeaveClassSelection, skin)

-- functions to clientside
function setupPlayerForClassSelection(player)
	triggerClientEvent("setupPlayerForClassSelection", player)
end

function stopPlayerClassSelection(player)
	triggerClientEvent("stopPlayerClassSelection", player)
end

-- custom events test
--addEventHandler("onPlayerEnterClassSelection", root, function() outputChatBox("onPlayerEnterClassSelection() source: " .. getPlayerName(source)) end)
--addEventHandler("onPlayerLeaveClassSelection", root, function(skin) outputChatBox("onPlayerLeaveClassSelection(" .. skin .. ") source: " .. getPlayerName(source)) end, skin)